#include <avr/io.h>
#define F_CPU 16000000
#include <util/delay.h>

int v[18];
int nr=0;

void aprinde_led(int index){
	if (index==0){
		PORTA|=1<<PA0;
		PORTC|=1<<PC0;
		
	}
	else if(index==1){
		PORTA|=1<<PA0;
		PORTC|=1<<PC1;
	}
	else if (index==2){
		PORTA|=1<<PA0;
		PORTC|=1<<PC2;
	}
	else if (index==3){
		PORTA|=1<<PA0;
		PORTC|=1<<PC3;
	}
	else if (index==4){
		PORTA|=1<<PA0;
		PORTC|=1<<PC4;
	}
	else if (index==5){
		PORTA|=1<<PA0;
		PORTC|=1<<PC5;
	}
	else if (index==6){
		PORTA|=1<<PA1;
		PORTC|=1<<PC0;
	}
	else if (index==7){
		PORTA|=1<<PA1;
		PORTC|=1<<PC1;
	}
	else if (index==8){
		PORTA|=1<<PA1;
		PORTC|=1<<PC2;
	}
	else if (index==9){
		PORTA|=1<<PA1;
		PORTC|=1<<PC3;
	}
	else if (index==10){
		PORTA|=1<<PA1;
		PORTC|=1<<PC4;
	}
	else if (index==11){
		PORTA|=1<<PA1;
		PORTC|=1<<PC5;
	}
	else if (index==12){
		PORTA|=1<<PA2;
		PORTC|=1<<PC0;
	}
	else if (index==13){
		PORTA|=1<<PA2;
		PORTC|=1<<PC1;
	}
	else if (index==14){
		PORTA|=1<<PA2;
		PORTC|=1<<PC2;
	}
	else if (index==15){
		PORTA|=1<<PA2;
		PORTC|=1<<PC3;
	}
	else if (index==16){
		PORTA|=1<<PA2;
		PORTC|=1<<PC4;
	}
	else if (index==17){
		PORTA^=1<<PA2;
		PORTC^=1<<PC5;
	}
}

void stinge_led(int index){
	if (index==0){
		PORTA&=~(1<<PA0);
		PORTC&=~(1<<PC0);
		
	}
	else if(index==1){
		PORTA&=~(1<<PA0);
		PORTC&=~(1<<PC1);
	}
	else if (index==2){
		PORTA&=~(1<<PA0);
		PORTC&=~(1<<PC2);
	}
	else if (index==3){
		PORTA&=~(1<<PA0);
		PORTC&=~(1<<PC3);
	}
	else if (index==4){
		PORTA&=~(1<<PA0);
		PORTC&=~(1<<PC4);	}
	else if (index==5){
		PORTA&=~(1<<PA0);
		PORTC&=~(1<<PC5);
	}
	else if (index==6){
		PORTA&=~(1<<PA1);
		PORTC&=~(1<<PC0);
	}
	else if (index==7){
		PORTA&=~(1<<PA1);
		PORTC&=~(1<<PC1);
	}
	else if (index==8){
		PORTA&=~(1<<PA1);
		PORTC&=~(1<<PC2);
	}
	else if (index==9){
		PORTA&=~(1<<PA1);
		PORTC&=~(1<<PC3);
	}
	else if (index==10){
		PORTA&=~(1<<PA1);
		PORTC&=~(1<<PC4);
	}
	else if (index==11){
		PORTA&=~(1<<PA1);
		PORTC&=~(1<<PC5);
	}
	else if (index==12){
		PORTA&=~(1<<PA2);
		PORTC&=~(1<<PC0);
	}
	else if (index==13){
		PORTA&=~(1<<PA2);
		PORTC&=~(1<<PC1);	}
	else if (index==14){
		PORTA&=~(1<<PA2);
		PORTC&=~(1<<PC2);
	}
	else if (index==15){
		PORTA&=~(1<<PA2);
		PORTC&=~(1<<PC3);
	}
	else if (index==16){
		PORTA&=~(1<<PA2);
		PORTC&=~(1<<PC4);
	}
	else if (index==17){
		PORTA&=~(1<<PA2);
		PORTC&=~(1<<PC5);
	}
}

void deseneaza_matrice(){
	int i=0;
	
	
	for(i=0;i<18;i++){
			if (v[i]==1){
				aprinde_led(i);
				nr++;
			}
			else stinge_led(i);
	}
	
	if (nr==18)
		for(i=0;i<18;i++){
			v[i]=0;
		}

}

int main()
{
	
	int i=0,apasat1=0,apasat2=0;
	DDRA|=1<<PA0;
	DDRA&=~(1<<PA3);
	PORTA|=1<<PA3;
	
	DDRA|=1<<PA1;
	DDRA&=~(1<<PA5);
	PORTA|=1<<PA5;
	
	DDRC=0xFF;
	
	for(i=0;i<18;i++){
		v[i]=1;
	}
	i=0;
	
	
	
	while(1){
		
		
		if (bit_is_clear(PINA,3)) //Check is the button is pressed
		{	
			if (apasat1==0){
				v[i]=1;				
				apasat1=1;
			}
		
		}
		else
		{
			apasat1=0;
		}
		
		if (bit_is_clear(PINA,5)){	
			
			if (apasat2==0){
				i++;
				if (i==18)
					i=0;
				apasat2=1;
			}
		}
		else
		{
			apasat2=0;
		}
		
		deseneaza_matrice();
		
	}
	
	
	return 0;
	
}
